#
#  ppml configuration file -- sitedef.ph
#
$Logfile = "pp.log";
$Savedir = "archive";
$Seqfile = "pp.seq";
$Cache   = "pp.cache";
$PPEHLOG = "ppeh.log";
$ERRORLOG = "pp.err";
# $USE_LOCKFILE = 1;
$CHKSUMTYPE = 'SHA1';
# $ALIASES = "/etc/aliases";
# $AUTOGENERATE = 1;
# loop-mail forwarded to ML_ADMIN but don't send back error
$DISCARD_LOOP = 1; 
# loop-mail reject(may cause reject-mail loop)
# $DISCARD_LOOP = 0; 
$ML_SETTING_ROOT = "/usr/local/lib/ppml";
$ML_CONTROL = 'ppserv@enkai.org';
$ML_SERVER_ADMIN = 'ppserv-request@enkai.org';
$PPML_HOST = 'axia.enkai.org';
$SMTP_HOST = 'localhost:25';
$SESSIONMAXRCPTS = 100;
# $SENDMAIL = '/usr/sbin/sendmail -i';    
$MIMEANALYZE = 1;
$MAXBODYSIZE = 500000;
$MAXPARTSIZE = 250000;
%USERCOMMPERM = (
		'index',       '1',
		'get',         '1',
		'on',          '1',
		'off',         '1',
		'unsubscribe', '1',
		'who',         '1',
		'subscribe',   '1',
		'confirm',     '1',
		'info',        '1',
		'help',        '1',
		);

sub DefaultMakeHeader{
    $0 = "MakeHeader";
    local(*e) = @_;
    local($mname);
    ### if you don't allow a field-name like "suBJeCt",
    # foreach $kk (keys(%e)){
    #     if ($kk =~ /^OH\:/){
    #         delete $e{$kk};
    #     }
    # }
    ### delete text/html part(sample:)
    # for ($b = 0 ; $b <= $e{'mp:00'} ; $b++){
    #   $mcb = sprintf("mp:%02d",$b);
    #   for ($i = 1 ; $i <= $e{$mcb} ; $i++){
    #     $mcs = sprintf("mp:%02d.%02d",$b,$i);
    #     if ($e{"mtype:$mcs"} =~ /text\/html/i){
    #         &DeletePart(*e,$b,$i);
    #     }
    #   }
    # }
    ### delete files based on extentions from attachment part(sample:)
    # for ($b = 0 ; $b <= $e{'mp:00'} ; $b++){
    #   $mcb = sprintf("mp:%02d",$b);
    #   for ($i = 1 ; $i <= $e{$mcb} ; $i++){
    #     $mcs = sprintf("mp:%02d.%02d",$b,$i);
    #     if (($e{"mname:$mcs"} =~ /(\.ade|\.adp|\.bas|\.bat|\.chm|\.cmd)/i)||
    #        ($e{"mname:$mcs"} =~ /(\.com|\.cpl|\.crt|\.css|\.exe|\.hlp)/i)||
    #        ($e{"mname:$mcs"} =~ /(\.hta|\.inf|\.ins|\.isp|\.js|\.jse)/i)||
    #        ($e{"mname:$mcs"} =~ /(\.lnk|\.mdb|\.mde|\.msc|\.msi|\.msp)/i)||
    #        ($e{"mname:$mcs"} =~ /(\.mst|\.pcd|\.pif|\.reg|\.scr|\.sct)/i)||
    #        ($e{"mname:$mcs"} =~ /(\.shs|\.url|\.vb|\.vbe|\.vbs|\.wsc)/i)||
    #        ($e{"mname:$mcs"} =~ /(\.wsf|\.wsh|\.csp|\.cab|\.pnf|\.ida)/i)){
    #        $mname = $e{"mname:$mcs"};
    #        &Log("$0:MIME:Deleted $mcs(= $mname) by extension($1).");
    #        &DeletePart(*e,$b,$i);
    #     }elsif($i > $e{"last:$mcb"}){
    #        &Log("$0:MIME:Deleted $mcs : Illegal part behind multipart terminator.");
    #        &DeletePart(*e,$b,$i);
    #     }
    #   }
    # }
    ### against Outlook buffer overflow
    if (length($e{'H:Date'}) >= 60 ) {
	&Log("$0:ALERT: Too Long Date Header: Outlook buffer overflow");
	delete $e{'H:Date'}; # Header will be generated by outgoing MTA
    }
    ### against JAPANESE SPAM
    @advstr = (
		  "\x21\x39\x2d\x39\x70\x21",
		  "\x21\x2a\x39\x2d\x39\x70\x21",
		  "\x21\x4f\x22\x4d\x6d\x4a\x7d\x4b\x21\x24\x4a\x24\x37\x21",
		  "\x21\x2a\x4f\x22\x4d\x6d\x4a\x7d\x4b\x21\x24\x4a\x24\x37\x21",
		  "\x21\x4f\x22\x4d\x6d\x4a\x7d\x4b\x21\x4c\x35\x21",
		  "\x21\x2a\x4f\x22\x4d\x6d\x4a\x7d\x4b\x21\x4c\x35\x21",
		  "\x21\x4f\x22\x4d\x6d\x4a\x7d\x4b\x21\x4c\x35\x24\x37\x21",
		  "\x21\x2a\x4f\x22\x4d\x6d\x4a\x7d\x4b\x21\x4c\x35\x24\x37\x21",
		  );
    foreach $bnn (@advstr){
	$ssssub = $e{'H:Subject'};
	$ssssub =~ s/\x1b\x24\x42//g;
	$ssssub =~ s/\x1b\x28\x42//g;
	if ($ssssub =~ /$bnn/ ){
	    &DecrSeqNum(*e);
	    chop($e{'H:Subject'});
	    &Log("$0:SPAM: DISCARDED!!");
	    &UnlockDone;
	}
    }
    ### against BubbleBoy virus
    if (($e{'H:Subject'} =~ /BubbleBoy is back\!/i ) &&
	($e{'Body'} =~ /http\:\/\/www\.towns\.com\/dorms\/tom\/bblboy\.htm/i )){
	&Log("$0:VIRUS: BubbleBoy detected");
	&NoticeMail($ML_ADMIN,"BubbleBoy detected($BRACKET)",$e{'Header'}.$e{'Body'},*r);
	&NoticeMail($ML_SERVER_ADMIN,"BubbleBoy detected($BRACKET)",$e{'Header'}.$e{'Body'},*r);
	&DecrSeqNum(*e);
	&UnlockDone;
    }
    ### against ILOVEYOU virus
    if (($e{'H:Subject'} =~ /ILOVEYOU/i ) &&
	($e{'Body'} =~ /kindly check the attached LOVELETTER coming from me/i )){
	&Log("$0:VIRUS: ILOVEYOU detected");
	&NoticeMail($ML_ADMIN,"ILOVEYOU detected($BRACKET)",$e{'Header'}.$e{'Body'},*r);
	&NoticeMail($ML_SERVER_ADMIN,"ILOVEYOU detected($BRACKET)",$e{'Header'}.$e{'Body'},*r);
	&DecrSeqNum(*e);
	&UnlockDone;
    }
    ### against 1-line Command
    if (defined($e{'seq'}) && ($e{'line:body'} <= 2)){
	if ($e{'Body'} =~ /^\s*(info|on|off|who|help|subscribe|unsubscribe)\s*\S*/i){
	    &Log("$0:COMM: Command from $e{'poster'} rejected");
	    &NoticeMail($e{'poster'},"Command rejected($BRACKET)",$e{'Header'}.$e{'Body'},*r);
	    &DecrSeqNum(*e);
	    &UnlockDone;
	}
    }
    ### delete header
    delete $e{'H:Received'};
    delete $e{'H:Return-Path'};
    delete $e{'H:X-Authentication-Warning'};
    delete $e{'H:Return-Receipt-To'};           # to avoid DSN storm
    delete $e{'H:Disposition-Notification-To'}; # to avoid MDN storm
    ### change header
    $e{'H:Subject'} =~ s/\n//g;
    $e{'H:Subject'} =~ s/\[$BRACKET\s+\d+\]\s*//;
    1 while $e{'H:Subject'} =~ s/\s*Re\:\s*Re\:\s*/Re\: /i ;
    $e{'H:Subject'} = "[$BRACKET $e{'seq'}] ".$e{'H:Subject'}."\n";
    $e{'H:Subject'} =~ s/([\ \t])[\ \t]+/$1/g;
    $e{'H:Reply-To'} = $e{'H:Reply-To'} || "$ML_ADDR\n";
    ### overwrite header
    $e{'H:Sender'} = "$ML_ADMIN\n";
    $e{'H:Precedence'} = "bulk\n";
    $e{'H:X-Sequence'} = "$BRACKET $e{'seq'}\n";
    $e{'OH:X-Ml-System'} = "X-ML-System";
    $e{'H:X-Ml-System'} = "Pigeon Post ver.0.734\n";

    return 1;
}

1;
